package com.nisum.mytime.model;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.format.annotation.DateTimeFormat.ISO;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

@Setter
@Getter
@AllArgsConstructor
@NoArgsConstructor
@ToString
@Document(collection = "Teams")
public class Project implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    private ObjectId id;
    private String projectId;
    private String projectName;
    /*
     * After Ui Integration this below commented code will be removed
     */
   //private String managerId;
   // private String managerName;
   // private String account;
    private String domain;
    private String status;
    private List<String> employeeIds;
    private List<String> managerIds;
    private String accountId;
    private String domainId;
    @DateTimeFormat(iso = ISO.DATE)
    private Date projectStartDate;
    @DateTimeFormat(iso = ISO.DATE)
    private Date projectEndDate;
    private List<String> deliveryLeadIds;

}
